import {Field, FieldType, Model} from '../../../orm'
import {OAuth2Token} from '../types'

export class OAuth2TokenModel extends Model<OAuth2TokenModel> implements OAuth2Token {
    public static table = 'oauth2_tokens'

    public static key = 'oauth2_token_id'

    @Field(FieldType.serial, 'oauth2_token_id')
    protected oauth2TokenId!: number

    public get id(): string {
        return String(this.oauth2TokenId)
    }

    @Field(FieldType.varchar, 'user_id')
    public userId!: string

    @Field(FieldType.varchar, 'client_id')
    public clientId!: string

    @Field(FieldType.timestamp)
    public issued!: Date

    @Field(FieldType.timestamp)
    public expires!: Date

    @Field(FieldType.varchar)
    public scope?: string
}
